<script setup lang="ts">
import type { PagePermission } from '~/models/role'
import Error from '~/components/pub/my-ui/error/error.vue'
import { PAGE_PERMISSIONS } from '~/lib/page-permission'

definePageMeta({
  middleware: ['rbac'],
  roles: ['doctor', 'nurse', 'admisi', 'pharmacy', 'billing', 'management'],
  title: 'Tambah Kunjungan',
  contentFrame: 'cf-full-width',
})

const route = useRoute()

useHead({
  title: () => `${route.meta.title}`, // backtick to avoid the ts-plugin(2322) warning
})

const roleAccess: PagePermission = PAGE_PERMISSIONS['/rehab/registration']

const { checkRole, hasCreateAccess } = useRBAC()

// Check if user has access to this page
const hasAccess = checkRole(roleAccess)
if (!hasAccess) {
  throw createError({
    statusCode: 403,
    statusMessage: 'Access denied',
  })
}

// Define permission-based computed properties
const canCreate = hasCreateAccess(roleAccess)
</script>

<template>
  <template v-if="canCreate">
    <ContentEncounterEntry form-type="Tambah" />
  </template>
  <Error v-else :status-code="403" />
</template>
